torchrun --nproc_per_node=4 --master_port 21322 main_read_w_augmented.py \
    --base_model 'mistralai/Mistral-7B-v0.1' \
    --micro_batch_size 2 \
    --batch_size 96 \
    --learning_rate 2e-5 \
    --lora_r 16 \
    --lora_alpha 8 \
    --lora_dropout 0.1 \
    --cutoff_len 1024 \
    --num_epochs 2 \
    --main_oversampling_rate 2 \
    --augmented_buckets 2 \
    --lora_target_modules '["q_proj","k_proj","v_proj","o_proj","gate_proj","up_proj","down_proj","lm_head"]' \
    --train_data_path PATH_TO_PROCESSED_MR_DATA/train_strict.json \
    --train_aug_path PATH_TO_PROCESSED_MR_DATA/MR-augmented/ \
    --eval_data_path PATH_TO_PROCESSED_MR_DATA/validation_strict.json \
    --cache_dir HF_CACHE_DIR \
    --output_dir OUTPUT_DIR